%
% epsilon4
%

clear;

[nw1,dw1,nw2,dw2,alpha,Npoints,amp,lw1,lw2,Lpoints]=data;

nsw1=star(nw1);
dsw1=star(dw1);
nsw2=star(nw2);
dsw2=star(dw2);

a1=conv(nsw1,nw1);
b1=conv(dsw1,dw1);
a2=conv(nsw2,nw2);
b2=conv(dsw2,dw2);

A=polyadd(conv(a1,b2),conv(a2,b1));
B=conv(b1,b2);

[dG,nG]=spec(A,B);

if length(alpha)==0,
   nw0h=0;
   dw0h=1;
else
    N=length(alpha);
    for k=1:N,
        C(k)=polyval(dG,alpha(k))^2/polyval(nG,alpha(k)) ...
             *mn(alpha(k))^(-1)*polyval(dw1,alpha(k));
    end;
    nw0h=(vander(alpha)\C.').';
    dw0h=conv(dw1,dG);
end;

k=1;
per=[];
wval=[];
for lw=lw1:(lw2-lw1)/Lpoints:lw2,
    w=10^lw;
    wval=[wval lw];
    s=i*w;
    n=polyval(nw1,s)/polyval(dw1,s);
    d=polyval(nw2,s)/polyval(dw2,s);
    per(k)=abs(n*d/sqrt(abs(n)^2+abs(d)^2)) ...
           +abs(n*n/sqrt(abs(n)^2+abs(d)^2)) ...
           +abs(polyval(nw0h,s)/polyval(dw0h,s));
    k=k+1;
end;

plot(wval,per);    
grid;
xlabel('log(w)');
ylabel('|w0|+|w0h|+|g0|');
title('eps_4=max(|w0|+|w0h|+|g0|)');

eps4=max(per)
